/*
 * Copyright (c) 1996-1998 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Flux OSKit.  The OSKit is free software, also known
 * as "open source;" you can redistribute it and/or modify it under the terms
 * of the GNU General Public License (GPL), version 2, as published by the Free
 * Software Foundation (FSF).  To explore alternate licensing terms, contact
 * the University of Utah at csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The OSKit is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with the OSKit; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 */
/*
 * Hack to do printfs to the real console.
 */

#include <oskit/x86/pc/direct_cons.h>
#include <oskit/c/stdarg.h>

void _doprnt(
	register	const char *fmt,
	va_list		args,
	int		radix,		/* default radix - for '%r' */
 	void		(*putc)(),	/* character output */
	char		*putc_arg);	/* argument for putc */

static void
dprintf_char(int ignored, int c)
{
	direct_cons_putchar(c);
}

void
dprintf(char *fmt, ...)
{
	va_list args;

	va_start(args, fmt);
	_doprnt(fmt, args, 0, (void (*)())dprintf_char, 0);
	va_end(args);
}
