/*
 * Copyright (c) 1999 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * Contributed by the Computer Security Research division,
 * INFOSEC Research and Technology Office, NSA.
 * 
 * This file is part of the Flux OSKit.  The OSKit is free software, also known
 * as "open source;" you can redistribute it and/or modify it under the terms
 * of the GNU General Public License (GPL), version 2, as published by the Free
 * Software Foundation (FSF).  To explore alternate licensing terms, contact
 * the University of Utah at csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The OSKit is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with the OSKit; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 */
/* FLASK */

#ifndef _EXTTRTAB_H_
#define _EXTTRTAB_H_

#include "hashtab.h"


typedef struct
{
    security_id_t source_sid;
    security_id_t target_sid;
    unsigned int object_class;
} exttr_key_t;


typedef security_id_t exttr_datum_t;


typedef struct 
{
    hashtab_t table;		/* hash table (keyed on an exttr_key_t) */
    unsigned int unused;	/* unused */
} exttrtab_t;

int exttrtab_init(exttrtab_t *);

#endif _EXTTRTAB_H_

/* FLASK */
